<?php
/*
------time capsule------
1.this file is totally used to move the files from the tempFolder to the actual root folder of wp
2.this file uses files from wordpress and also plugins to perform the copying actions
 */
/**
* created by thamaraiselvam
* created on 28-06-2017
*/

class WPTC_Copy{
	private $common_include_files,
			$restore_app_functions,
			$config,
			$restore_id,
			$post_data;

	function __construct(){

		//create object for restore app common
		$this->init_restore_app_functions();

		//enable PHP errors
		$this->restore_app_functions->enable_php_errors();

		//set global starting time
		$this->restore_app_functions->start_request_time();

		//define restore constant to override other functions
		$this->restore_app_functions->define_constants();

		//restore needed files
		$this->include_files();

		//start database connections
		$this->restore_app_functions->init_db_connection();

		$this->restore_app_functions->init_other_objects();

		$this->restore_app_functions->init_other_functions();

		//assume this is request from server
		set_server_req_wptc();

		//Init WP File system
		$this->restore_app_functions->init_file_system();


		$this->config = WPTC_Factory::get('config');

		$this->log_recent_calls();

		$this->setup_restore();

		$this->check_request();

		$this->restore_app_functions->init_log_files();

		//start db dump and copy files
		$this->process_files();
	}

	public function include_files(){
		require_once dirname(__FILE__). '/' ."common_include_files.php";
		$this->common_include_files = new Common_Include_Files('wptc-copy');
		$this->common_include_files->init();
	}

	private function init_restore_app_functions(){
		//common app functions for both ajax and tc-init
		require_once dirname(__FILE__). '/' ."wptc-restore-app-functions.php";
		$this->restore_app_functions = new WPTC_Restore_App_Functions();
	}

	private function log_recent_calls(){
		$this->config->set_option('recent_restore_ping', time());
	}

	private function setup_restore(){
		$this->restore_id = $this->config->get_option('restore_action_id');
	}

	private function check_request(){
		$this->post_data = $this->restore_app_functions->decode_request();
		global $is_staging_req;
		$is_staging_req = 0; // this is not a staging request by default

		//USE THIS WHEN META / STAGING RESTORE IS BACK
		// $is_meta_data_req = $this->is_meta_data_req();
		// if($is_meta_data_req){
		// 	$this->common_include_files->init('meta_restore');
		// 	$this->restore_app_functions->init_db_connection();
		// 	$this->log_recent_calls();
		// } else if($staging_req_type){
		// 	$this->post_data = $this->restore_app_functions->decode_request();
		// 	$is_staging_req = 1;
		// 	$initialize = 0;
		// 	if ($staging_req_type == 1) {
		// 		$this->post_data['initialize'] = true;
		// 	}
		// 	$this->common_include_files->init();
		// 	$this->restore_app_functions->init_db_connection();
		// 	$this->log_recent_calls();
		// 	$this->process_files();
		// }

	}

	// private function is_meta_data_req(){
	// 	$data = $this->restore_app_functions->decode_request();
	// 	if (empty($data)) {
	// 		return false;
	// 	}
	// 	if ($data['action'] == 'import_meta_file') {
	// 		return true;
	// 	}
	// 	return false;
	// }

	// private function staging_req_type(){
	// 	$data = $this->restore_app_functions->decode_request();
	// 	if (empty($data)) {
	// 		return false;
	// 	}
	// 	if ($data['action'] == 'staging_restore' && !empty($data['initialize']) && $data['initialize'] == 'true') {
	// 		return 1;
	// 	} else if ($data['action'] == 'staging_restore') {
	// 		return 2;
	// 	}
	// 	return false;
	// }

	private function process_files(){
		// global $is_staging_req;
		global $wp_filesystem, $wpdb;

		//update the options table to indicate that bridge process is going on , only on the first call
		$this->reset_flags();

		$this->is_restore_completed();

		$restore_temp_folder = $this->config->get_option('backup_db_path') . '/tCapsule';
		$restore_temp_folder_fs_safe = $this->config->wp_filesystem_safe_abspath_replace($restore_temp_folder);

		//change the path is its staging request
		// if (!empty($is_staging_req)) {
		// 	$restore_temp_folder = $restore_temp_folder_fs_safe;
		// }

		$content_name = basename($this->config->get_option('backup_db_path'));
		$site_db_name = $this->config->get_option('site_db_name');

		if ($content_name == 'uploads') {
			$restore_db_dump_dir = $restore_temp_folder . '/wp-content/' . $content_name . '/tCapsule/backups/';
			$restore_db_dump_dir_fs_safe = $restore_temp_folder_fs_safe . 'wp-content/' . $content_name . '/tCapsule/backups/';;
		} else {
			$restore_db_dump_dir = $restore_temp_folder . '/' . $content_name . '/tCapsule/backups/';
			$restore_db_dump_dir_fs_safe = $restore_temp_folder_fs_safe . $content_name . '/tCapsule/backups/';
		}

		$restore_db_dump_file = $restore_db_dump_dir . $site_db_name . '-backup.sql';
		$restore_db_dump_file_fs_safe = $restore_db_dump_dir_fs_safe . $site_db_name . '-backup.sql';

		// if (!empty($is_staging_req)) {
		// 	$restore_db_dump_file = $restore_db_dump_file_fs_safe;
		// }

		//check if the db restore process is already completed
		if ($this->config->get_option('restore_db_process')) {

			//check if the sql file is selected during restore process, if it doesnt exist then we dont need to do the restore db process
			if (!$wp_filesystem->exists($restore_db_dump_file_fs_safe)) {
				dark_debug(array(), '-----------db file not found in this restore-------------');
				$this->config->set_option('restore_db_process', false);
				$this->config->set_option('restore_db_index', 0);
				$this->restore_app_functions->die_with_msg('wptcs_callagain_wptce');
			}

			// if ($is_staging_req && $this->post_data['initialize']) {
			// 	$this->change_new_prefix_to_staging($this->config, $restore_db_dump_file_fs_safe);
			// }

			dark_debug(array(), '-----------db file found in this restore-------------');

			$this->enable_maintenance_mode();

			$db_restore_result = $this->database_restore($restore_db_dump_file);

			if (!$db_restore_result) {
				$this->handle_restore_error_wptc($this->config);
				$err_obj = array();
				$err_obj['restore_db_dump_file'] = $restore_db_dump_file;
				$err_obj['mysql_error'] = $wpdb->last_error;
				$err = array('error' => $err_obj);
				$this->disable_maintenance_mode();
				WPTC_Base_Factory::get('Wptc_Backup_Analytics')->send_report_data($this->restore_id, 'RESTORE', 'FAILED');
				$this->restore_app_functions->die_with_msg($err);
			}

			//on db restore completion - set the following values
			$this->config->set_option('restore_db_process', false);
			$this->config->set_option('restore_db_index', 0);
			@unlink($restore_db_dump_file);
			$this->restore_app_functions->die_with_msg('wptcs_callagain_wptce');
		}

		//first delete the sql file then carryout the copying files process
		if ($wp_filesystem->exists($restore_db_dump_file_fs_safe)) {
			$wp_filesystem->delete($restore_db_dump_file_fs_safe);
		}

		$this->enable_maintenance_mode();

		$full_copy_result = $this->config->tc_file_system_move_dir($restore_temp_folder_fs_safe, ABSPATH, $this->restore_app_functions);

		$this->disable_maintenance_mode();

		if (!empty($full_copy_result) && is_array($full_copy_result) && array_key_exists('error', $full_copy_result)) {
			$this->restore_app_functions->die_with_msg($full_copy_result);
		} else {
			//if we set this value as false ; then the bridge process for copying is completed
			$this->config->set_option('is_bridge_process', false);
			$this->restore_complete();
		}

		$this->is_restore_completed();
	}

	private function reset_flags(){
		dark_debug($this->post_data, '---------$this->post_data------------');
		if (empty($this->post_data) || empty($this->post_data['initialize']) || $this->post_data['initialize'] != true) {
			return false;
		}

		$this->config->set_option('is_bridge_process', true);
		$this->config->set_option('restore_db_index', 0);
		$this->config->set_option('restore_saved_index', 0);
		$this->config->set_option('restore_db_process', true);
	}

	private function is_restore_completed(){
		if (!$this->config->get_option('is_bridge_process') && !$this->config->get_option('garbage_deleted')) {
			WPTC_Base_Factory::get('Wptc_Backup_Analytics')->send_report_data($this->restore_id, 'RESTORE', 'SUCCESS');
			$this->restore_app_functions->die_with_msg('wptcs_over_wptce');
		}
	}

	private function enable_maintenance_mode() {
		global $wp_filesystem;
		$file_content = '<?php global $upgrading; $upgrading = time();';

		$config = WPTC_Factory::get('config');

		$file_name = $config->wp_filesystem_safe_abspath_replace(ABSPATH);
		$file_name .= '.maintenance';

		$wp_filesystem->put_contents($file_name, $file_content);
	}

	private function disable_maintenance_mode() {
		$maintenance_file = $this->config->wp_filesystem_safe_abspath_replace(ABSPATH);
		$maintenance_file .= '.maintenance';

		global $wp_filesystem;

		if ($wp_filesystem->is_file($maintenance_file)) {
			$wp_filesystem->delete($maintenance_file);
		}
	}

	private function restore_complete($error = false) {
		$this->disable_maintenance_mode();

		$this->config->set_option('restore_completed_notice', 'yes');


		//delete the bridge files on completion
		$this->delete_bridge_folder();

		$this->config->set_option('in_progress_restore', false);
		$this->config->set_option('is_running_restore', false);
		$this->config->set_option('cur_res_b_id', false);
		$this->config->set_option('start_renaming_sql', false);
		$this->config->set_option('restore_db_index', 0);
		$this->config->set_option('got_files_list_for_restore_to_point', 0);
		$this->config->set_option('live_files_to_restore_table', 0);
		$this->config->set_option('recorded_files_to_restore_table', 0);
		$this->config->set_option('selected_files_temp_restore', 0);
		$this->config->set_option('selected_backup_type_restore', 0);
		$this->config->set_option('got_selected_files_to_restore', 0);
		$this->config->set_option('not_safe_for_write_files', 0);
		$this->config->set_option('recorded_this_selected_folder_restore', 0);
		$this->config->set_option('recent_restore_ping', false);
		$this->config->set_option('is_bridge_process', false);
		$this->config->set_option('get_recorded_files_to_restore_table', false);
		$this->config->set_option('restore_current_action', false);

		$processed_restore = new WPTC_Processed_Restoredfiles();
		$processed_restore->truncate();
		global $wpdb;
		$wpdb->query("TRUNCATE TABLE `" . $wpdb->base_prefix . "wptc_current_process`");
		$wpdb->query("TRUNCATE TABLE `" . $wpdb->base_prefix . "wptc_processed_iterator`");

		$this->config->remove_garbage_files(array('is_restore' => true));

		if (!empty($error)) {
			$this->disable_maintenance_mode();
			$this->restore_app_functions->die_with_msg($error);
		}

		WPTC_Base_Factory::get('Wptc_Backup_Analytics')->send_report_data($this->restore_id, 'RESTORE', 'SUCCESS');

		$failure_data = $this->restore_app_functions->get_failure_data();

		if (empty($failure_data)) {
			$this->restore_app_functions->die_with_msg('wptcs_over_wptce');
		} else {
			$this->restore_app_functions->die_with_msg(array('status' => 'wptcs_over_wptce', 'failure_data' => $failure_data) );
		}
	}

	private function delete_bridge_folder(){
		global $wp_filesystem;

		$backup_db_path = $this->config->get_option('backup_db_path');
		$backup_db_path = $this->config->wp_filesystem_safe_abspath_replace($backup_db_path. 'wptcrquery/wptc_saved_queries_restore.sql');

		if ($wp_filesystem->exists($backup_db_path)) {
			$wp_filesystem->delete($backup_db_path);
		}
	}

	private function handle_restore_error_wptc() {
		$this->config->remove_garbage_files(array('is_restore' => true));
		$this->config->set_option('restore_db_process', false);
		$this->config->set_option('is_bridge_process', false);
		$this->config->set_option('restore_db_index', 0);
		$this->restore_complete('Restoring DB error.');
	}

	// private function change_new_prefix_to_staging(&$this->config, $db_file, $meta_data_import = null, $meta_db_prefixes = array()){
	// 	global $current_db_prefix, $new_db_prefix;
	// 	dark_debug(array(), '---------change_new_prefix_to_staging------------');
	// 	dark_debug($meta_data_import, '---------$meta_data_import------------');
	// 	if ($meta_data_import === 1) {
	// 		$current_db_prefix = $meta_db_prefixes['current_db_prefix'];
	// 		$new_db_prefix = $meta_db_prefixes['new_db_prefix'];
	// 	} else {
	// 		$current_db_prefix = $this->config->get_option('current_db_prefix');;
	// 		$new_db_prefix = $this->config->get_option('new_db_prefix');
	// 	}
	// 	dark_debug($current_db_prefix, '---------$current_db_prefix------------');
	// 	dark_debug($new_db_prefix, '---------$new_db_prefix------------');
	// 	if ($current_db_prefix === $new_db_prefix) {
	// 		dark_debug(array(), '---------prefix are not same------------');
	// 		return false;
	// 	}
	// 	dark_debug($db_file, '---------$db_file sending to modify------------');
	// 	modify_db_dump($db_file);
	// }

	// private function modify_db_dump($db_file){
	// 	$lines = file($db_file);
	// 	@unlink($db_file);
	// 	dark_debug(array(), '---------db file unlinked------------');

	// 	// Loop through each line
	// 	if (count($lines) && !empty($lines)) {
	// 		foreach ($lines as $i => $line) {

	// 			// Skip it if it's a comment
	// 			if (substr($line, 0, 2) == '--' || $line == '' || substr($line, 0, 3) == '/*!')
	// 				continue;

	// 			$line = preg_replace_callback("/(TABLE[S]?|INSERT\ INTO|DROP\ TABLE\ IF\ EXISTS) [`]?([^`\;\ ]+)[`]?/", 'search_and_replace_prefix', $line);
	// 			// Add this line to the current segment
	// 			if (file_put_contents($db_file, $line, FILE_APPEND) === FALSE)
					// $this->disable_maintenance_mode();
	// 				$this->restore_app_functions->die_with_msg('Error: Cannot write db file.');
	// 		}
	// 		return true;
	// 	} else {
	// 		return false;
	// 	}
	// }

	// private function search_and_replace_prefix($matches){
	// 	global $current_db_prefix, $new_db_prefix;
	// 	$subject = $matches[0];
	// 	$old_table_name = $matches[2];
	// 	$new_table_name = preg_replace("/$current_db_prefix/", $new_db_prefix, $old_table_name, 1);
	// 	return str_replace($old_table_name, $new_table_name, $subject);
	// }

	private	function database_restore($file_name, $meta_data_import = null , $meta_db_prefixes = array()) {
		dark_debug(func_get_args(), "--------" . __FUNCTION__ . "--------");
		// global $is_staging_req;
		global $wpdb;

		// if ($meta_data_import === 1) {
		// 	dark_debug(array(), '---------tc_database_restore------------');
		// 	$this->change_new_prefix_to_staging($this->config, $file_name, $meta_data_import = 1, $meta_db_prefixes);
		// }

		$prev_index = $this->config->get_option('restore_db_index');
		$last_index = $this->config->get_option('restore_saved_index');

		dark_debug($prev_index, '---------$prev_index------------');
		dark_debug($last_index, '---------$last_index------------');

		if (empty($meta_data_import)) {
			manual_debug_wptc('', 'startingDBBridgeRestore');
			manual_debug_wptc('', 'beforeReadingDBFile');
		}

		$current_query = '';

		$handle = fopen($file_name, "r");

		// if (empty($meta_data_import)) {
		// 	manual_debug_wptc('', 'afterReadingDBFile');
		// }

		if (empty($handle)) {
			dark_debug(array(), '--------Cannot open the database file--------');
			$this->disable_maintenance_mode();
			$err = array('error' => 'Cannot open database file');
			$this->disable_maintenance_mode();
			WPTC_Base_Factory::get('Wptc_Backup_Analytics')->send_report_data($this->restore_id, 'RESTORE', 'FAILED');
			$this->restore_app_functions->die_with_msg($err);
		}

		$this_lines_count = 0;
		$loop_iteration = 0;

		while (($line = fgets($handle)) !== false) {

			$loop_iteration++;

			if (!empty($prev_index) && $loop_iteration <= $prev_index) {
				continue; //check index;if it is previously written ; then continue;
			}

			$this_lines_count++;

			if (substr($line, 0, 2) == '--' || $line == '') {
				continue; // Skip it if it's a comment
			}

			$current_query .= $line;

			// If it does not have a semicolon at the end, then it's not the end of the query
			if (substr(trim($line), -1, 1) != ';') {
				continue;
			}

			// if ($this->is_unwanted_query_staging($current_query)) {
			// 	dark_debug($current_query, '---------$current_query rejected------------');
			// 	continue;
			// }

			$result = $wpdb->query($current_query);

			if ($result === false) {
				//log failed queries
				$this->restore_app_functions->log_data('queries', $current_query);
			}

			$current_query = '';

			if ($this_lines_count <= 10) {
				continue;
			}

			$this_lines_count = 0;

			$result = maybe_call_again(1);

			if ($result != true) {
				continue;
			}

			$wpdb->query('UNLOCK TABLES;');
			$this->config->set_option('restore_db_index', $loop_iteration); //updating the status in db for each 10 lines
			// if (!empty($meta_data_import)) {
			// 	return $loop_iteration;
			// }
			fclose($handle);
			$this->restore_app_functions->die_with_msg('wptcs_callagain_wptce');
		}

		$wpdb->query('UNLOCK TABLES;');

		// if (!empty($meta_data_import)) {
		// 	$this->config->set_option('meta_restore_completed', 1); //updating the status in db for each 10 lines
		// 	return 'meta restore completed';
		// }

		$basename_db_path = basename($this->config->get_option('backup_db_path'));

		// if (!empty($is_staging_req)) {
		// 	$basename_db_path = $this->config->wp_filesystem_safe_abspath_replace($basename_db_path);
		// }

		if ($basename_db_path == 'uploads') {
			$savedQueryDir = $this->config->get_option('backup_db_path') . '/tCapsule/'.basename(WPTC_WP_CONTENT_DIR).'/uploads/wptcrquery';
		} else {
			$savedQueryDir = $this->config->get_option('backup_db_path') . '/tCapsule/'.basename(WPTC_WP_CONTENT_DIR).'/wptcrquery';
		}

		if (!is_dir($savedQueryDir)) {
			return true;
		}

		$sql_files = $this->get_all_db_sql_files($savedQueryDir);

		usort($sql_files, array($this, 'cmp_wptc_sql_array'));

		if (count($sql_files) > 0) {
			foreach ($sql_files as $val) {
				if (strpos($val, '.sql') !== false) {
					$content = file_get_contents($savedQueryDir . '/' . $val);
					$restoreSql = fopen($savedQueryDir . '/wptc_saved_queries_restore.sql', 'a+');
					fwrite($restoreSql, $content);
					@unlink($savedQueryDir . '/' . $val);
					fclose($restoreSql);
				}
			}
		}

		manual_debug_wptc('', 'afterAppendingFile');
		$saved_query_file = $savedQueryDir . '/wptc_saved_queries_restore.sql';
		$linesinsql = fopen($saved_query_file, "r");
		manual_debug_wptc('', 'afterReadingSqls');

		if (!$linesinsql) {
			manual_debug_wptc('', 'endingBridgeRestore');
			return true;
		}

		$this_lines_count = 0;
		$s_loop_iteration = 0;

		while (($sline = fgets($linesinsql)) !== false) {

			$s_loop_iteration++;

			if (!empty($last_index) && $s_loop_iteration <= $last_index) {
				continue; //check index;if it is previously written ; then continue;
			}

			$this_lines_count++;

			if (substr($sline, 0, 2) == '--' || $sline == '') {
				continue; // Skip it if it's a comment
			}

			$current_query .= $sline;

			if (substr(trim($sline), -1, 1) != ';') {
				continue;
			}

			$result = $wpdb->query($current_query); // If it has a semicolon at the end, it's the end of the query

			if ($result == false) {
				//SAVE HERE FOR FAILED QUERIES
			}

			$current_query = '';

			if ($this_lines_count < 10) {
				continue;
			}

			$this_lines_count = 0;
			$result = maybe_call_again(1);

			if ($result != true) {
				continue;
			}

			$wpdb->query('UNLOCK TABLES;');
			$this->config->set_option('restore_saved_index', $s_loop_iteration);
			fclose($linesinsql);
			$this->restore_app_functions->die_with_msg('wptcs_callagain_wptce');
		}

		return true;
	}

	private function get_all_db_sql_files($path){
		$sql_files = array();
		$file_iterator = new WPTC_File_Iterator();
		$files_obj = $file_iterator->get_files_obj_by_path($path, $recursive = 1);
		foreach ($files_obj as $key => $file) {
				$file_path = $file->getPathname();
				$file_name= basename($file_path);
				if ($file_name == '.' || $file_name == '..' || !$file->isReadable() || stripos($file_path, 'wptc_saved_queries_restore.sql') ) {
					continue;
				}
				$sql_files[] = $file_name;
		}
		return $sql_files;
	}

	private function replace_wptc_sercet_custom($raw_data){
		$response = $raw_data;
		$headerPos = stripos($response, 'wptc_saved_queries.sql.');
		if($headerPos !== false){
			$response = substr($response, $headerPos);
			$response = substr($response, strlen('wptc_saved_queries.sql.'), stripos($response, '-wptc-')-strlen('wptc_saved_queries.sql.'));
			$result = str_replace($response, '', $raw_data);
		}
		return $result;
	}

	private function cmp_wptc_sql_array($ta, $tb){
		$a = $this->replace_wptc_sercet_custom($ta);
		$b = $this->replace_wptc_sercet_custom($tb);
		return strcmp($a, $b);
	}

	private function is_unwanted_query_staging($req_query){
		$queries = array('CREATE DATABASE IF NOT EXISTS ', 'USE ');
		foreach ($queries as $query) {
			if (strpos($req_query, $query) !== FALSE) {
				return true;
			}
		}
		return false;
	}
}
new WPTC_Copy();
